import { __awaiter, __generator } from "tslib";
import { join } from "path";
import { getHomeDir } from "./getHomeDir";
import { normalizeConfigFile } from "./normalizeConfigFile";
import { parseIni } from "./parseIni";
import { slurpFile } from "./slurpFile";
export var ENV_CREDENTIALS_PATH = "AWS_SHARED_CREDENTIALS_FILE";
export var ENV_CONFIG_PATH = "AWS_CONFIG_FILE";
var swallowError = function () { return ({}); };
export var loadSharedConfigFiles = function (init) {
    if (init === void 0) { init = {}; }
    return __awaiter(void 0, void 0, void 0, function () {
        var _a, filepath, _b, configFilepath, parsedFiles;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _a = init.filepath, filepath = _a === void 0 ? process.env[ENV_CREDENTIALS_PATH] || join(getHomeDir(), ".aws", "credentials") : _a, _b = init.configFilepath, configFilepath = _b === void 0 ? process.env[ENV_CONFIG_PATH] || join(getHomeDir(), ".aws", "config") : _b;
                    return [4, Promise.all([
                            slurpFile(configFilepath).then(parseIni).then(normalizeConfigFile).catch(swallowError),
                            slurpFile(filepath).then(parseIni).catch(swallowError),
                        ])];
                case 1:
                    parsedFiles = _c.sent();
                    return [2, {
                            configFile: parsedFiles[0],
                            credentialsFile: parsedFiles[1],
                        }];
            }
        });
    });
};
